#ifndef _cimple_Atomic_LINUX_AARCH64_GNU_h
#define _cimple_Atomic_LINUX_AARCH64_GNU_h

#include "config.h"

#define CIMPLE_ATOMIC_INITIALIZER { 0 }

CIMPLE_NAMESPACE_BEGIN

struct Atomic
{
    int n;
};

inline void Atomic_create(Atomic* atomic, int x)
{
    atomic->n = x;
}

inline void Atomic_destroy(Atomic* atomic)
{
}

inline int Atomic_get(const Atomic* atomic)
{
    int value;
    __atomic_load (&atomic->n, &value, __ATOMIC_SEQ_CST);
    return value;
}

inline void Atomic_set(Atomic* atomic, int x)
{
    __atomic_store (&atomic->n, &x, __ATOMIC_SEQ_CST);
}

static __inline__ void Atomic_inc(Atomic* atomic)
{
    __atomic_add_fetch(&atomic->n, 1, __ATOMIC_SEQ_CST);
}

static __inline__ int Atomic_dec_and_test(Atomic* atomic)
{
    return __atomic_add_fetch(&atomic->n, -1, __ATOMIC_SEQ_CST) == 0;
}

static __inline__ void Atomic_dec(Atomic* atomic)
{
    __atomic_add_fetch(&atomic->n, -1, __ATOMIC_SEQ_CST);
}

CIMPLE_NAMESPACE_END

#endif /* _cimple_Atomic_LINUX_IX86_GNU_h */
